(defun c:roof2d-pts ( / *error* mid car-sort inside-p processtxtipl chksolution test chklili collinear-p nCr findallpts findst1t2 tttt offschk sim s ti lw lwx lwi pl tl ipt1t2t3l lil n wcs offflg )

  (defun *error* ( m )
    (if (and lwi (not (vlax-erased-p lwi)))
      (entdel lwi)
    )
    (if wcs
      (if ucsf
        (exe (list "_.UCS" "_P"))
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if initvalueslst
      (mapcar (function apply_cadr->car) initvalueslst)
    )
    (foreach fun (list (quote tttt) (quote vl-load) (quote exe) (quote cmdfun) (quote cmderr) (quote catch_cont) (quote apply_cadr->car) (quote ftoa))
      (setq fun nil)
    )
    (if doc
      (vla-regen doc acactiveviewport)
    )
    (if m
      (prompt m)
    )
    (princ)
  )

  (defun mid ( p1 p2 )
    (mapcar (function (lambda ( a b ) (/ (+ a b) 2.0))) p1 p2)
  )

  (defun car-sort ( lst cmp / rtn )
    (setq rtn (car lst))
    (foreach itm (cdr lst)
      (if (apply cmp (list itm rtn))
        (setq rtn itm)
      )
    )
    rtn
  )

  (defun inside-p ( pt lw lwi )
    (< (distance pt (vlax-curve-getclosestpointto lwi pt)) (distance pt (vlax-curve-getclosestpointto lw pt)))
  )

  (defun processtxtipl ( tl / ipl tl1 tl2 intt )
    (setq tl1 tl tl2 tl)
    (foreach t1 tl1
      (foreach t2 (setq tl2 (cdr tl2))
        (if (setq intt (inters (car t1) (polar (car t1) (angle (car t1) (cadr t1)) 1.0) (car t2) (polar (car t2) (angle (car t2) (cadr t2)) 1.0) nil))
          (setq ipl (cons intt ipl))
          (setq ipl (cons (angle (car t1) (cadr t1)) ipl))
        )
      )
    )
    ipl
  )

  (defun chksolution ( errli / allplanesips anglst )
    (if (and (car errli) (cadr errli))
      (progn
        (setq allplanesips (processtxtipl tl))
        (setq allplanesips (vl-remove-if (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) pl))) allplanesips))
        (setq anglst (vl-remove-if (function listp) allplanesips))
        (if (vl-some (function (lambda ( x ) (or (equal x 1e-8 1e-6) (equal x -1e-8 1e-6)))) anglst)
          (setq anglst (cons 0.0 anglst) anglst (cons pi anglst) anglst (cons (* 2 pi) anglst))
        )
        (setq allplanesips (vl-remove-if-not (function listp) allplanesips))
        (if (or
              (vl-some (function (lambda ( x ) (or
                                                 (equal (distance (car errli) (cadr errli)) (+ (distance (car errli) x) (distance x (cadr errli))) 1e-8)
                                                 (equal (distance (car errli) x) (+ (distance (car errli) (cadr errli)) (distance (cadr errli) x)) 1e-8)
                                                 (equal (distance (cadr errli) x) (+ (distance (cadr errli) (car errli)) (distance (car errli) x)) 1e-8)
                                               )
                                 )) allplanesips
              )
              (vl-some (function (lambda ( x ) (or (equal (angle (car errli) (cadr errli)) x 1e-8) (equal (angle (cadr errli) (car errli)) x 1e-8)))) anglst)
              (vl-some (function (lambda ( x ) (collinear-p (car errli) (cadr errli) x))) pl)
            )
          t
        )
      )
      t
    )
  )

  (defun test nil
    (and (not (vl-some (function (lambda ( x ) (and (not (vl-some (function (lambda ( y ) (inters (car x) (cadr x) (car y) (cadr y)))) lil)) (not (vl-some (function (lambda ( y ) (equal (distance (car y) (cadr y)) (+ (distance (car y) (polar (car x) (angle (car x) (cadr x)) 0.1)) (distance (polar (car x) (angle (car x) (cadr x)) 0.01) (cadr y))) 1e-6))) tl)) (inside-p (polar (car x) (angle (car x) (cadr x)) 0.01) lw lwi) (inside-p (polar (cadr x) (angle (cadr x) (car x)) 0.01) lw lwi)))) ll)) (vl-every (function (lambda ( li ) (chksolution li))) lil) (vl-every (function (lambda ( x ) (vl-some (function (lambda ( y ) (equal x y 1e-6))) (apply (function append) lil)))) pl) (not (vl-some (function (lambda ( li1 ) (vl-some (function (lambda ( li2 / ip ) (and (setq ip (inters (car li1) (cadr li1) (car li2) (cadr li2))) (not (equal ip (car li1) 1e-6)) (not (equal ip (cadr li1) 1e-6)) (not (equal ip (car li2) 1e-6)) (not (equal ip (cadr li2) 1e-6))))) (vl-remove li1 lil)))) lil)))
  )

  (defun chklili ( lil / lilpts )
    (setq lilpts (apply (function append) lil))
    (setq lilpts (vl-remove-if-not (function (lambda ( x ) (= (length (vl-remove-if (function (lambda (y) (equal x y 1e-6))) lilpts)) (- (length lilpts) 2)))) lilpts))
    lilpts
  )

  (defun collinear-p ( p1 p2 p3 )
    (
      (lambda ( a b c )
        (or
          (equal (+ a b) c 1e-10)
          (equal (+ b c) a 1e-10)
          (equal (+ c a) b 1e-10)
        )
      )
      (distance p1 p2) (distance p2 p3) (distance p1 p3)
    )
  )

  (defun nCr ( lst r )
    (cond
      ( (< r 2)
        (mapcar (function list) lst)
      )
      ( lst
        (append
          (mapcar (function (lambda ( x ) (cons (car lst) x))) (nCr (cdr lst) (1- r)))
          (nCr (cdr lst) r)
        )
      )
    )
  )

  (defun findallpts ( tl / t1 t2 t3 ip12 ip23 s12 s121 s122 s23 s231 s232 ip d1 d2 ipl )
    (foreach t1t2t3 (nCr tl 3)
      (setq t1 (car t1t2t3) t2 (cadr t1t2t3) t3 (caddr t1t2t3))
      (setq ip12 (inters (car t1) (cadr t1) (car t2) (cadr t2) nil) s12 nil)
      (if ip12
        (setq s121 (polar ip12 (angle ip12 (mid (polar ip12 (angle ip12 (car-sort t1 (function (lambda ( a b ) (> (distance ip12 a) (distance ip12 b)))))) 1.0) (polar ip12 (angle ip12 (car-sort t2 (function (lambda ( a b ) (> (distance ip12 a) (distance ip12 b)))))) 1.0))) 1.0) s122 (polar ip12 (angle ip12 (mid (polar ip12 (angle ip12 (car-sort t1 (function (lambda ( a b ) (> (distance ip12 a) (distance ip12 b)))))) -1.0) (polar ip12 (angle ip12 (car-sort t2 (function (lambda ( a b ) (> (distance ip12 a) (distance ip12 b)))))) 1.0))) 1.0))
        (setq ip12 (mid (car t1) (car t2)) s12 (polar ip12 (angle (car t1) (cadr t1)) 1.0))
      )
      (setq ip23 (inters (car t2) (cadr t2) (car t3) (cadr t3) nil) s23 nil)
      (if ip23
        (setq s231 (polar ip23 (angle ip23 (mid (polar ip23 (angle ip23 (car-sort t2 (function (lambda ( a b ) (> (distance ip23 a) (distance ip23 b)))))) 1.0) (polar ip23 (angle ip23 (car-sort t3 (function (lambda ( a b ) (> (distance ip23 a) (distance ip23 b)))))) 1.0))) 1.0) s232 (polar ip23 (angle ip23 (mid (polar ip23 (angle ip23 (car-sort t2 (function (lambda ( a b ) (> (distance ip23 a) (distance ip23 b)))))) -1.0) (polar ip23 (angle ip23 (car-sort t3 (function (lambda ( a b ) (> (distance ip23 a) (distance ip23 b)))))) 1.0))) 1.0))
        (setq ip23 (mid (car t2) (car t3)) s23 (polar ip23 (angle (car t2) (cadr t2)) 1.0))
      )
      (if (and s12 s23)
        (progn
          (setq ip (inters ip12 s12 ip23 s23 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
        )
      )
      (if (and s12 (not s23))
        (progn
          (setq ip (inters ip12 s12 ip23 s231 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
          (setq ip (inters ip12 s12 ip23 s232 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
        )
      )
      (if (and (not s12) s23)
        (progn
          (setq ip (inters ip12 s121 ip23 s23 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
          (setq ip (inters ip12 s122 ip23 s23 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
        )
      )
      (if (and (not s12) (not s23))
        (progn
          (setq ip (inters ip12 s121 ip23 s231 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
          (setq ip (inters ip12 s121 ip23 s232 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
          (setq ip (inters ip12 s122 ip23 s231 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
          (setq ip (inters ip12 s122 ip23 s232 nil))
          (if (and ip (inside-p ip lw lwi) (or (< (setq d1 (distance ip (inters ip (polar ip (+ (angle (car t1) (cadr t1)) (* 0.5 pi)) 1.0) (car t1) (cadr t1) nil))) (setq d2 (distance ip (vlax-curve-getclosestpointto lw ip)))) (equal d1 d2 1e-6)) (not (equal d1 0.0 1e-6)))
            (setq ipl (cons (list ip t1 t2 t3) ipl))
          )
        )
      )
    )
    ipl
  )

  (defun findst1t2 ( t1 t2 / ip )
    (if (setq ip (inters (car t1) (cadr t1) (car t2) (cadr t2) nil))
      (list ip (angle ip (polar ip (angle ip (mid (polar ip (angle ip (car-sort t1 (function (lambda ( a b ) (> (distance ip a) (distance ip b)))))) 1.0) (polar ip (angle ip (car-sort t2 (function (lambda ( a b ) (> (distance ip a) (distance ip b)))))) 1.0))) 1.0)))
      (list (mid (car t1) (car t2)) (angle (car t1) (cadr t1)))
    )
  )

  (defun dd ( p tl / dl )
    (foreach tt tl
      (setq dl
        (cons
          (distance
            (mapcar (function +) (list 0.0 0.0) (trans p 1 (mapcar (function -) (cadr tt) (car tt))))
            (mapcar (function +) (list 0.0 0.0) (trans (car tt) 1 (mapcar (function -) (cadr tt) (car tt))))
          )
          dl
        )
      )
    )
    dl
  )

  (defun tttt ( wcs / sysvarpreset sysvarlst sysvarvals ) ;;; wcs (T/nil) ;;; cad, doc, alo, spc - global variables (Visual Lisp main VLA-OBJECT pointers) ;;; vl-load exe cmdfun cmderr catch_cont apply_cadr->car ftoa - library sub functions common for standard template initialization ;;;

    (defun vl-load nil
      (or cad
        (if vlax-get-acad-object
          (setq cad (vlax-get-acad-object))
          (progn
            (vl-load-com)
            (setq cad (vlax-get-acad-object))
          )
        )
      )
      (or doc (setq doc (vla-get-activedocument cad)))
      (or alo (setq alo (vla-get-activelayout doc)))
      (or spc (setq spc (vla-get-block alo)))
    )

    ;;; sometimes not needed to use/initialize AxiveX Visual Lisp extensions - (comment/uncomment) following line ;;;
    (or (and cad doc alo spc) (vl-load))

    (defun exe ( tokenslist )
      ( (lambda ( tokenslist / ctch )
          (if (vl-catch-all-error-p (setq ctch (cmdfun tokenslist t)))
            (progn
              (cmderr tokenslist)
              (catch_cont ctch)
            )
            (progn
              (while (< 0 (getvar (quote cmdactive)))
                (vl-cmdf "")
              )
              t
            )
          )
        )
        tokenslist
      )
    )

    (defun cmdfun ( tokenslist flag / ctch ) ;;; tokenslist - command parameters list of strings ;;; flag - if "t" specified, upon successful execution returns t, otherwise if "nil" specified, return is always nil no matter what outcome of function execution is - it should be successful anyway if specified tokenslist was hardcoded correctly... ;;;
      (if command-s
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command-s) tokenslist)))
            ctch
          )
        )
        (if flag
          (if (not (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function vl-cmdf) tokenslist))))
            flag
            ctch
          )
          (if (vl-catch-all-error-p (setq ctch (vl-catch-all-apply (function command) tokenslist)))
            ctch
          )
        )
      )
    )

    (defun cmderr ( tokenslist ) ;;; tokenslist - list of tokens representing command syntax at which used (cmdfun) failed with successful execution ;;;
      (prompt (strcat "\ncommand execution failure... error at used command tokenslist : " (vl-prin1-to-string tokenslist)))
    )

    (defun catch_cont ( ctch / gr )
      (prompt "\nleft mouse click to continue or enter to generate catch error - ESC to break...")
      (while
        (and
          (vl-catch-all-error-p (or ctch (setq ctch (vl-catch-all-apply (function /) (list 1 0)))))
          (setq gr (grread))
          (/= (car gr) 3)
          (not (equal gr (list 2 13)))
        )
      )
      (if (vl-catch-all-error-p ctch)
        ctch
      )
    )

    (defun apply_cadr->car ( sysvarvaluepair / ctch )
      (setq ctch (vl-catch-all-apply (function setvar) sysvarvaluepair))
      (if (vl-catch-all-error-p ctch)
        (progn
          (prompt (strcat "\ncatched error on setting system variable : " (vl-prin1-to-string (vl-symbol-name (car sysvarvaluepair))) " with value : " (vl-prin1-to-string (cadr sysvarvaluepair))))
          (catch_cont ctch)
        )
      )
    )

    (defun ftoa ( n / m a s b )
      (if (numberp n)
        (progn
          (setq m (fix ((if (< n 0) - +) n 1e-8)))
          (setq a (abs (- n m)))
          (setq m (itoa m))
          (setq s "")
          (while (and (not (equal a 0.0 1e-6)) (setq b (fix (* a 10.0))))
            (setq s (strcat s (itoa b)))
            (setq a (- (* a 10.0) b))
          )
          (if (= (type n) (quote int))
            m
            (if (= s "")
              m
              (if (and (= m "0") (< n 0))
                (strcat "-" m "." s)
                (strcat m "." s)
              )
            )
          )
        )
      )
    )

    (setq sysvarpreset
      (list
        (list (quote cmdecho) 0)
        (list (quote 3dosmode) 0)
        (list (quote osmode) 0)
        (list (quote unitmode) 0)
        (list (quote cmddia) 0)
        (list (quote ucsvp) 0)
        (list (quote ucsortho) 0)
        (list (quote projmode) 0)
        (list (quote orbitautotarget) 0)
        (list (quote insunits) 0)
        (list (quote hpseparate) 0)
        (list (quote hpgaptol) 0)
        (list (quote halogap) 0)
        (list (quote edgemode) 0)
        (list (quote pickdrag) 0)
        (list (quote qtextmode) 0)
        (list (quote dragsnap) 0)
        (list (quote angdir) 0)
        (list (quote aunits) 0)
        (list (quote limcheck) 0)
        (list (quote gridmode) 0)
        (list (quote nomutt) 0)
        (list (quote apbox) 0)
        (list (quote attdia) 0)
        (list (quote blipmode) 0)
        (list (quote copymode) 0)
        (list (quote circlerad) 0.0)
        (list (quote filletrad) 0.0)
        (list (quote filedia) 1)
        (list (quote autosnap) 1)
        (list (quote objectisolationmode) 1)
        (list (quote highlight) 1)
        (list (quote lispinit) 1)
        (list (quote layerpmode) 1)
        (list (quote fillmode) 1)
        (list (quote dragmodeinterrupt) 1)
        (list (quote dispsilh) 1)
        (list (quote fielddisplay) 1)
        (list (quote deletetool) 1)
        (list (quote delobj) 1)
        (list (quote dblclkedit) 1)
        (list (quote attreq) 1)
        (list (quote explmode) 1)
        (list (quote frameselection) 1)
        (list (quote ltgapselection) 1)
        (list (quote pickfirst) 1)
        (list (quote plinegen) 1)
        (list (quote plinetype) 1)
        (list (quote peditaccept) 1)
        (list (quote solidcheck) 1)
        (list (quote visretain) 1)
        (list (quote regenmode) 1)
        (list (quote celtscale) 1.0)
        (list (quote ltscale) 1.0)
        (list (quote osnapcoord) 2)
        (list (quote grips) 2)
        (list (quote dragmode) 2)
        (list (quote lunits) 2)
        (list (quote pickstyle) 3)
        (list (quote navvcubedisplay) 3)
        (list (quote pickauto) 3)
        (list (quote draworderctl) 3)
        (list (quote expert) 5)
        (list (quote auprec) 6)
        (list (quote luprec) 6)
        (list (quote pickbox) 6)
        (list (quote aperture) 6)
        (list (quote osoptions) 7)
        (list (quote dimzin) 8)
        (list (quote pdmode) 35)
        (list (quote pdsize) -1.5)
        (list (quote celweight) -1)
        (list (quote cecolor) "BYLAYER")
        (list (quote celtype) "ByLayer")
        (list (quote clayer) "0")
      )
    )
    (setq sysvarlst (mapcar (function car) sysvarpreset))
    (setq sysvarvals (mapcar (function cadr) sysvarpreset))
    (setq sysvarvals
      (vl-remove nil
        (mapcar
          (function (lambda ( x )
            (if (getvar x) (nth (vl-position x sysvarlst) sysvarvals))
          ))
          sysvarlst
        )
      )
    )
    (setq sysvarlst
      (vl-remove-if-not
        (function (lambda ( x )
          (getvar x)
        ))
        sysvarlst
      )
    )
    (setq initvalueslst
      (apply (function mapcar)
        (cons (function list)
          (list
            sysvarlst
            (mapcar (function getvar) sysvarlst)
          )
        )
      )
    )
    (apply (function mapcar)
      (cons (function setvar)
        (list
          sysvarlst
          sysvarvals
        )
      )
    )
    (while (= 8 (logand 8 (getvar (quote undoctl))))
      (if (not (exe (list "_.UNDO" "_E")))
        (if doc
          (vla-endundomark doc)
        )
      )
    )
    (if (not (exe (list "_.UNDO" "_M")))
      (if doc
        (vla-startundomark doc)
      )
    )
    (if wcs
      (if (= 0 (getvar (quote worlducs)))
        (progn
          (exe (list "_.UCS" "_W"))
          (setq ucsf t)
        )
      )
    )
    wcs
  )

  (defun sim ( pt p11 p12 p21 p22 / ip p1 p2 mp mpp )
    (setq ip (inters p11 p12 p21 p22 nil))
    (if
      (and
        ip
        (= 2 (length (vl-remove-if (function (lambda ( x ) (equal x ip 1e-6))) (list p11 p12 p21 p22))))
        (setq p1 (car (vl-remove-if (function (lambda ( x ) (equal x ip 1e-6))) (list p11 p12 p21 p22))))
        (setq p2 (cadr (vl-remove-if (function (lambda ( x ) (equal x ip 1e-6))) (list p11 p12 p21 p22))))
      )
      (progn
        (setq mp (mapcar (function (lambda ( a b ) (/ (+ a b) 2.0))) (polar ip (angle ip p1) 1.0) (polar ip (angle ip p2) 1.0)))
        (if
          (and
            mp
            (setq mpp (mapcar (function +) ip (mapcar (function -) ip mp)))
            (or
              (equal (distance ip pt) (+ (distance ip mp) (distance mp pt)) 1e-6)
              (equal (distance ip pt) (+ (distance ip mpp) (distance mpp pt)) 1e-6)
            )
          )
          pt
        )
      )
    )
  )

  (defun offschk ( offflg pl p tl / el flagg ddd di offl ppl )
    (setq el (entlast))
    (setq ddd (vl-sort (dd p tl) (function <)))
    (setq di
      (vl-some
        (function (lambda ( x )
          (if (<= 2 (- (length ddd) (length (vl-remove-if (function (lambda ( y ) (equal x y 1e-5))) ddd)))) x)
        ))
        ddd
      )
    )
    (if di
      (if offflg
        (setq offl (vl-catch-all-apply (function vlax-invoke) (list (vlax-ename->vla-object lw) (quote offset) (- (- di 1e-4)))))
        (setq offl (vl-catch-all-apply (function vlax-invoke) (list (vlax-ename->vla-object lw) (quote offset) (+ (- di 1e-4)))))
      )
    )
    (if (and offl (not (vl-catch-all-error-p offl)))
      (progn
        (setq offl (mapcar (function vlax-vla-object->ename) offl))
        (foreach off offl
          (setq ppl (append (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) (entget off))) ppl))
        )
      )
    )
    (if
      (vl-some
        (function (lambda ( x )
          (equal x p 1e-2)
        ))
        pl
      )
      (setq flagg t)
      (setq flagg (<= 2 (- (length ppl) (length (vl-remove-if (function (lambda ( x ) (equal x p 1e-2))) ppl)))))
    )
    (while (setq el (entnext el))
      (if (and el (not (vlax-erased-p el)))
        (entdel el)
      )
    )
    flagg
  )

  (setq wcs (tttt t))
  (prompt "\nPick a closed polygonal LWPOLYLINE...")
  (if (setq s (ssget "_+.:E:S" (list (cons 0 "LWPOLYLINE") (cons -4 "&=") (cons 70 1) (cons -4 "<not") (cons -4 "<>") (cons 42 0.0) (cons -4 "not>"))))
    (progn
      (setq ti (car (_vl-times)))
      (setq lwx (entget (setq lw (ssname s 0))))
      (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset 0.001))))
      (if (< (vlax-curve-getarea lw) (vlax-curve-getarea lwi))
        (progn
          (entdel lwi)
          (setq lwi (vlax-vla-object->ename (car (vlax-invoke (vlax-ename->vla-object lw) 'offset -0.001))))
          (setq pl (mapcar (function (lambda ( p ) (mapcar (function +) (list 0 0) (trans p lw 0)))) (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) lwx))))
          (setq offflg t)
        )
        (progn
          (setq pl (reverse (mapcar (function (lambda ( p ) (mapcar (function +) (list 0 0) (trans p lw 0)))) (mapcar (function cdr) (vl-remove-if (function (lambda ( x ) (/= (car x) 10))) lwx)))))
        )
      )
      (setq tl (mapcar (function (lambda ( a b ) (list a b))) pl (append (cdr pl) (list (car pl)))))
      (setq ipt1t2t3l (findallpts tl))
      (foreach ipt1t2t3 ipt1t2t3l
        (if
          (or
            (sim (car ipt1t2t3) (caadr ipt1t2t3) (cadadr ipt1t2t3) (car (caddr ipt1t2t3)) (cadr (caddr ipt1t2t3)))
            (sim (car ipt1t2t3) (car (caddr ipt1t2t3)) (cadr (caddr ipt1t2t3)) (car (nth 3 ipt1t2t3)) (cadr (nth 3 ipt1t2t3)))
            (sim (car ipt1t2t3) (caadr ipt1t2t3) (cadadr ipt1t2t3) (car (nth 3 ipt1t2t3)) (cadr (nth 3 ipt1t2t3)))
          )
          ;|
          (cond
            ( (and (offschk offflg pl (car ipt1t2t3) tl) (offschk offflg pl (caadr ipt1t2t3) tl))
              (setq lil (cons (list (car ipt1t2t3) (caadr ipt1t2t3)) lil))
            )
            ( (and (offschk offflg pl (car ipt1t2t3) tl) (offschk offflg pl (cadadr ipt1t2t3) tl))
              (setq lil (cons (list (car ipt1t2t3) (cadadr ipt1t2t3)) lil))
            )
            ( (and (offschk offflg pl (car ipt1t2t3) tl) (offschk offflg pl (car (caddr ipt1t2t3)) tl))
              (setq lil (cons (list (car ipt1t2t3) (car (caddr ipt1t2t3))) lil))
            )
            ( (and (offschk offflg pl (car ipt1t2t3) tl) (offschk offflg pl (cadr (caddr ipt1t2t3)) tl))
              (setq lil (cons (list (car ipt1t2t3) (cadr (caddr ipt1t2t3))) lil))
            )
            ( (and (offschk offflg pl (car ipt1t2t3) tl) (offschk offflg pl (car (nth 3 ipt1t2t3)) tl))
              (setq lil (cons (list (car ipt1t2t3) (car (nth 3 ipt1t2t3))) lil))
            )
            ( (and (offschk offflg pl (car ipt1t2t3) tl) (offschk offflg pl (cadr (nth 3 ipt1t2t3)) tl))
              (setq lil (cons (list (car ipt1t2t3) (cadr (nth 3 ipt1t2t3))) lil))
            )
          )
          |;

          (if (offschk offflg pl (car ipt1t2t3) tl)
            (entmake (list (cons 0 "POINT") (cons 10 (car ipt1t2t3)) (cons 62 4)))
          )

        )
      )
      ;|
      (setq n (length pl))
      (if (and lil (test) (not (chklili lil)) (<= n (length lil)))
        (foreach li lil
          (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li)) (cons 62 3)))
        )
        (progn
          (prompt "\nNO SOLUTION FOUND...")
          (foreach li lil
            (entmake (list (cons 0 "LINE") (cons 10 (car li)) (cons 11 (cadr li)) (cons 62 1)))
          )
        )
      )
      |;
      (prompt "\nElapsed time : ") (princ (ftoa (- (car (_vl-times)) ti))) (prompt " milliseconds...")
      (prompt "\nFor UNDO - type \"UNDO\" - \"Back\" option...")
    )
  )
  (*error* nil)
)